package net.shadowfacts.extrahoppers.init

import net.minecraft.item.BlockItem
import net.minecraft.item.Item
import net.minecraft.util.Identifier
import net.minecraft.util.registry.Registry
import net.shadowfacts.extrahoppers.block.gold.GoldHopperBlock
import net.shadowfacts.extrahoppers.block.gold.InvertedGoldHopperBlock
import net.shadowfacts.extrahoppers.block.grate.GrateBlock
import net.shadowfacts.extrahoppers.block.wood.WoodHopperBlock

object EHItems {

    val WOOD_HOPPER = BlockItem(EHBlocks.WOOD_HOPPER, Item.Settings())
    val GOLD_HOPPER = BlockItem(EHBlocks.GOLD_HOPPER, Item.Settings())
    val INVERTED_GOLD_HOPPER = BlockItem(EHBlocks.INVERTED_GOLD_HOPPER, Item.Settings())
    val GRATE = BlockItem(EHBlocks.GRATE, Item.Settings())

    fun init() {
        register(WoodHopperBlock.ID, WOOD_HOPPER)
        register(GoldHopperBlock.ID, GOLD_HOPPER)
        register(InvertedGoldHopperBlock.ID, INVERTED_GOLD_HOPPER)
        register(GrateBlock.ID, GRATE)
    }

    private fun register(id: Identifier, item: Item) {
        Registry.register(Registry.ITEM, id, item)
    }

}
